require('.concepts-1')

----
--- @class LuaPlayerBuiltEntityEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`, `"force"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaPlayerMinedEntityEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaPlayerRepairedEntityEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaPostEntityDiedEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. Can only be `"type"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaPreGhostDeconstructedEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaPreGhostUpgradedEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaPrePlayerMinedEntityEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaPreRobotMinedEntityEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaRobotBuiltEntityEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`, `"force"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaRobotMinedEntityEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaScriptRaisedBuiltEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaScriptRaisedDestroyEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaScriptRaisedReviveEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaScriptRaisedTeleportedEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaSectorScannedEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class LuaUpgradeCancelledEventFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"ghost"`, `"rail"`, `"rail-signal"`, `"rolling-stock"`, `"robot-with-logistics-interface"`, `"vehicle"`, `"turret"`, `"crafting-machine"`, `"wall-connectable"`, `"transport-belt-connectable"`, `"circuit-network-connectable"`, `"type"`, `"name"`, `"ghost_type"`, `"ghost_name"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class MapAndDifficultySettings
--- All regular [MapSettings](MapSettings) plus an additional table that contains the [DifficultySettings](DifficultySettings).
--- 
--- @field pollution PollutionMapSettings 
--- @field enemy_evolution EnemyEvolutionMapSettings 
--- @field enemy_expansion EnemyExpansionMapSettings 
--- @field unit_group UnitGroupMapSettings 
--- @field steering SteeringMapSettings 
--- @field path_finder PathFinderMapSettings 
--- @field max_failed_behavior_count uint If a behavior fails this many times, the enemy (or enemy group) is destroyed. This solves biters getting stuck within their own base.
--- @field difficulty_settings DifficultySettings 
----

----
--- @class MapExchangeStringData
--- The data that can be extracted from a map exchange string, as a plain table.
--- 
--- @field map_settings MapAndDifficultySettings 
--- @field map_gen_settings MapGenSettings 
----

----
--- @class MapGenPreset
--- 
--- @field order string The string used to alphabetically sort the presets. It is a simple string that has no additional semantic meaning.
--- @field default boolean? Whether this is the preset that is selected by default.
--- @field basic_settings MapGenSettings? 
--- @field advanced_settings AdvancedMapGenSettings? 
----

----
--- @class MapGenSettings
--- The 'map type' dropdown in the map generation GUI is actually a selector for elevation generator. The base game sets `property_expression_names.elevation` to `"0_16-elevation"` to reproduce terrain from 0.16 or to `"0_17-island"` for the island preset. If generators are available for other properties, the 'map type' dropdown in the GUI will be renamed to 'elevation' and shown along with selectors for the other selectable properties.
--- 
--- @field terrain_segmentation MapGenSize The inverse of 'water scale' in the map generator GUI. Lower `terrain_segmentation` increases the scale of elevation features (lakes, continents, etc). This behavior can be overridden with alternate elevation generators (see `property_expression_names`, below).
--- @field water MapGenSize The equivalent to 'water coverage' in the map generator GUI. Specifically, when this value is non-zero, `water_level = 10 * log2` (the value of this field), and the elevation generator subtracts water level from elevation before adding starting lakes. If water is set to 'none', elevation is clamped to a small positive value before adding starting lakes. This behavior can be overridden with alternate elevation generators (see `property_expression_names`, below).
--- @field autoplace_controls table<string,AutoplaceControl> Indexed by autoplace control prototype name.
--- @field default_enable_all_autoplace_controls boolean Whether undefined `autoplace_controls` should fall back to the default controls or not. Defaults to `true`.
--- @field autoplace_settings table<string,AutoplaceSettings> Each setting in this dictionary maps the string type to the settings for that type. Valid types are `"entity"`, `"tile"` and `"decorative"`.
--- @field cliff_settings CliffPlacementSettings Map generation settings for entities of the type "cliff".
--- @field seed uint The random seed used to generated this map.
--- @field width uint Width in tiles. If `0`, the map has 'infinite' width, with the actual limitation being one million tiles in each direction from the center.
--- @field height uint Height in tiles. If `0`, the map has 'infinite' height, with the actual limitation being one million tiles in each direction from the center.
--- @field starting_area MapGenSize Size of the starting area.
--- @field starting_points MapPosition[] Positions of the starting areas.
--- @field peaceful_mode boolean Whether peaceful mode is enabled for this map.
--- @field property_expression_names table<string,string> Overrides for tile property value generators. Values either name a NamedNoiseExpression or can be literal numbers, stored as strings (e.g. `"5"`). All other controls can be overridden by a property expression names. Notable properties:  - `moisture` - a value between 0 and 1 that determines whether a tile becomes sandy (low moisture) or grassy (high moisture). - `aux` - a value between 0 and 1 that determines whether low-moisture tiles become sand or red desert. - `temperature` - provides a value (vaguely representing degrees Celsius, varying between -20 and 50) that is used (together with moisture and aux) as part of tree and decorative placement. - `elevation` - tiles values less than zero become water. Cliffs are placed along certain contours according to [CliffPlacementSettings](CliffPlacementSettings). - `cliffiness` - determines whether (when >0.5) or not (when <0.5) a cliff will be placed at an otherwise suitable (according to [CliffPlacementSettings](CliffPlacementSettings)) location. - `enemy-base-intensity` - a number that is referenced by both `enemy-base-frequency` and `enemy-base-radius`. i.e. if this is overridden, enemy base frequency and size will both be affected and do something reasonable. By default, this expression returns a value proportional to distance from any starting point, clamped at about 7. - `enemy-base-frequency` - a number representing average number of enemy bases per tile for a region, by default in terms of `enemy-base-intensity`. - `enemy-base-radius` - a number representing the radius of an enemy base, if one were to be placed on the given tile, by default proportional to a constant plus `enemy-base-intensity`. Climate controls ('Moisture' and 'Terrain type' at the bottom of the Terrain tab in the map generator GUI) don't have their own dedicated structures in MapGenSettings. Instead, their values are stored as property expression overrides with long names:  - `control-setting:moisture:frequency:multiplier` - frequency (inverse of scale) multiplier for moisture noise. Default is 1. - `control-setting:moisture:bias` - global bias for moisture (which normally varies between 0 and 1). Default is 0. - `control-setting:aux:frequency:multiplier` - frequency (inverse of scale) multiplier for aux (called 'terrain type' in the GUI) noise. Default is 1. - `control-setting:aux:bias` - global bias for aux/terrain type (which normally varies between 0 and 1). Default is 0. All other MapGenSettings feed into named noise expressions, and therefore placement can be overridden by including the name of a property in this dictionary. The probability and richness functions for placing specific tiles, entities, and decoratives can be overridden by including an entry named `{tile|entity|decorative}:(prototype name):{probability|richness}`.
----

----
--- @alias MapGenSize float|string
--- A floating point number specifying an amount.
--- 
--- For backwards compatibility, MapGenSizes can also be specified as one of the following strings, which will be converted to a number (when queried, a number will always be returned):
----

----
--- @alias MapPosition { x: double, y: double }
--- Coordinates on a surface, for example of an entity. MapPositions may be specified either as a dictionary with `x`, `y` as keys, or simply as an array with two elements.
--- 
--- The coordinates are saved as a fixed-size 32 bit integer, with 8 bits reserved for decimal precision, meaning the smallest value step is `1/2^8 = 0.00390625` tiles.
----

----
--- @class MapSettings
--- Various game-related settings. Updating any of the attributes will immediately take effect in the game engine.
--- 
--- @field pollution PollutionMapSettings 
--- @field enemy_evolution EnemyEvolutionMapSettings 
--- @field enemy_expansion EnemyExpansionMapSettings 
--- @field unit_group UnitGroupMapSettings 
--- @field steering SteeringMapSettings 
--- @field path_finder PathFinderMapSettings 
--- @field max_failed_behavior_count uint If a behavior fails this many times, the enemy (or enemy group) is destroyed. This solves biters getting stuck within their own base.
----

----
--- @class MapViewSettings
--- What is shown in the map view. If a field is not given, that setting will not be changed.
--- 
--- @field show-logistic-network boolean? 
--- @field show-electric-network boolean? 
--- @field show-turret-range boolean? 
--- @field show-pollution boolean? 
--- @field show-train-station-names boolean? 
--- @field show-player-names boolean? 
--- @field show-networkless-logistic-members boolean? 
--- @field show-non-standard-map-info boolean? 
----

----
--- @class ModChangeData
--- 
--- @field old_version string Old version of the mod. May be `nil` if the mod wasn't previously present (i.e. it was just added).
--- @field new_version string New version of the mod. May be `nil` if the mod is no longer present (i.e. it was just removed).
----

----
--- @class ModSetting
--- 
--- @field value double|boolean|int|string|Color The value of the mod setting. The type depends on the kind of setting.
----

----
--- @class ModSettingPrototypeFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"type"`, `"mod"`, `"setting-type"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class ModuleEffectValue
--- 
--- @field bonus float The percentual increase of the attribute. A value of `0.6` means a 60% increase.
----

----
--- @class ModuleEffects
--- 
--- @field consumption ModuleEffectValue? 
--- @field speed ModuleEffectValue? 
--- @field productivity ModuleEffectValue? 
--- @field pollution ModuleEffectValue? 
----

----
--- @class MouseButtonFlags
--- A set of flags. Active flags are in the dictionary as `true`, while inactive flags aren't present at all.
--- 
--- To write to this, use an array[[string](string)] of the mouse buttons that should be possible to use with on button. The flag `"left-and-right"` can also be set, which will set `"left"` and `"right"` to `true`.
--- 
--- @field left bool 
--- @field right bool 
--- @field middle bool 
--- @field button-4 bool 
--- @field button-5 bool 
--- @field button-6 bool 
--- @field button-7 bool 
--- @field button-8 bool 
--- @field button-9 bool 
----

----
--- @class NoiseExpression
--- A fragment of a functional program used to generate coherent noise, probably for purposes related to terrain generation. These can only be meaningfully written/modified during the data load phase. More detailed information is found on the [wiki](https://wiki.factorio.com/Types/NoiseExpression).
--- 
--- @field type string Names the type of the expression and determines what other fields are required.
----

----
--- @class NthTickEventData
--- 
--- @field tick uint The tick during which the event happened.
--- @field nth_tick uint The nth tick this handler was registered to.
----

----
--- @class Offer
--- A single offer on a market entity.
--- 
--- @field price Ingredient[] List of prices.
--- @field offer TechnologyModifier The action that will take place when a player accepts the offer. Usually a `"give-item"` modifier.
----

----
--- @class OldTileAndPosition
--- 
--- @field old_tile LuaTilePrototype 
--- @field position TilePosition 
----

----
--- @class PathFinderMapSettings
--- 
--- @field fwd2bwd_ratio uint The pathfinder performs a step of the backward search every `fwd2bwd_ratio`'th step. The minimum allowed value is `2`, which means symmetric search. The default value is `5`.
--- @field goal_pressure_ratio double When looking at which node to check next, their heuristic value is multiplied by this ratio. The higher it is, the more the search is directed straight at the goal. Defaults to `2`.
--- @field max_steps_worked_per_tick double The maximum number of nodes that are expanded per tick. Defaults to `1,000`.
--- @field max_work_done_per_tick uint The maximum amount of work each pathfinding job is allowed to do per tick. Defaults to `8,000`.
--- @field use_path_cache boolean Whether to cache paths at all. Defaults to `true`.
--- @field short_cache_size uint Number of elements in the short cache. Defaults to `5`.
--- @field long_cache_size uint Number of elements in the long cache. Defaults to `25`.
--- @field short_cache_min_cacheable_distance double The minimal distance to the goal in tiles required to be searched in the short path cache. Defaults to `10`.
--- @field short_cache_min_algo_steps_to_cache uint The minimal number of nodes required to be searched in the short path cache. Defaults to `50`.
--- @field long_cache_min_cacheable_distance double The minimal distance to the goal in tiles required to be searched in the long path cache. Defaults to `30`.
--- @field cache_max_connect_to_cache_steps_multiplier uint When looking for a connection to a cached path, search at most for this number of steps times the original estimate. Defaults to `100`.
--- @field cache_accept_path_start_distance_ratio double When looking for a path from cache, make sure it doesn't start too far from the requested start in relative terms. Defaults to `0.2`.
--- @field cache_accept_path_end_distance_ratio double When looking for a path from cache, make sure it doesn't end too far from the requested end in relative terms. This is typically more lenient than the start ratio since the end target could be moving. Defaults to `0.15`.
--- @field negative_cache_accept_path_start_distance_ratio double Same principle as `cache_accept_path_start_distance_ratio`, but used for negative cache queries. Defaults to `0.3`.
--- @field negative_cache_accept_path_end_distance_ratio double Same principle as `cache_accept_path_end_distance_ratio`, but used for negative cache queries. Defaults to `0.3`.
--- @field cache_path_start_distance_rating_multiplier double When assigning a rating to the best path, this multiplier times start distances is considered. Defaults to `10`.
--- @field cache_path_end_distance_rating_multiplier double When assigning a rating to the best path, this multiplier times end distances is considered. This value is typically higher than the start multiplier as this results in better end path quality. Defaults to `20`.
--- @field stale_enemy_with_same_destination_collision_penalty double A penalty that is applied for another unit that is on the way to the goal. This is mainly relevant for situations where a group of units has arrived at the target they are supposed to attack, making units further back circle around to reach the target. Defaults to `30`.
--- @field ignore_moving_enemy_collision_distance double The distance in tiles after which other moving units are not considered for pathfinding. Defaults to `5`.
--- @field enemy_with_different_destination_collision_penalty double A penalty that is applied for another unit that is too close and either not moving or has a different goal. Defaults to `30`.
--- @field general_entity_collision_penalty double The general collision penalty with other units. Defaults to `10`.
--- @field general_entity_subsequent_collision_penalty double The collision penalty for positions that require the destruction of an entity to get to. Defaults to `3`.
--- @field extended_collision_penalty double The collision penalty for collisions in the extended bounding box but outside the entity's actual bounding box. Defaults to `3`.
--- @field max_clients_to_accept_any_new_request uint The amount of path finder requests accepted per tick regardless of the requested path's length. Defaults to `10`.
--- @field max_clients_to_accept_short_new_request uint When the `max_clients_to_accept_any_new_request` amount is exhausted, only path finder requests with a short estimate will be accepted until this amount (per tick) is reached. Defaults to `100`.
--- @field direct_distance_to_consider_short_request uint The maximum direct distance in tiles before a request is no longer considered short. Defaults to `100`.
--- @field short_request_max_steps uint The maximum amount of nodes a short request will traverse before being rescheduled as a long request. Defaults to `1000`.
--- @field short_request_ratio double The amount of steps that are allocated to short requests each tick, as a percentage of all available steps. Defaults to `0.5`, or 50%.
--- @field min_steps_to_check_path_find_termination uint The minimum amount of steps that are guaranteed to be performed for every request. Defaults to `2000`.
--- @field start_to_goal_cost_multiplier_to_terminate_path_find double If the actual amount of steps is higher than the initial estimate by this factor, pathfinding is terminated. Defaults to `2000.0`.
--- @field overload_levels uint[] The thresholds of waiting clients after each of which the per-tick work limit will be increased by the corresponding value in `overload_multipliers`. This is to avoid clients having to wait too long. Must have the same number of elements as `overload_multipliers`. Defaults to `{0, 100, 500}`.
--- @field overload_multipliers double[] The multipliers to the amount of per-tick work applied after the corresponding thresholds in `overload_levels` have been reached. Must have the same number of elements as `overload_multipliers`. Defaults to `{2, 3, 4}`.
--- @field negative_path_cache_delay_interval uint The delay in ticks between decrementing the score of all paths in the negative cache by one. Defaults to `20`.
----

----
--- @class PathfinderFlags
--- 
--- @field allow_destroy_friendly_entities boolean? Allows pathing through friendly entities. Defaults to `false`.
--- @field allow_paths_through_own_entities boolean? Allows the pathfinder to path through entities of the same force. Defaults to `false`.
--- @field cache boolean? Enables path caching. This can be more efficient, but might fail to respond to changes in the environment. Defaults to `true`.
--- @field prefer_straight_paths boolean? Makes the pathfinder try to path in straight lines. Defaults to `false`.
--- @field low_priority boolean? Sets lower priority on the path request, meaning it might take longer to find a path at the expense of speeding up others. Defaults to `false`.
--- @field no_break boolean? Makes the pathfinder not break in the middle of processing this pathfind, no matter how much work is needed. Defaults to `false`.
----

----
--- @class PathfinderWaypoint
--- 
--- @field position MapPosition The position of the waypoint on its surface.
--- @field needs_destroy_to_reach boolean `true` if the path from the previous waypoint to this one goes through an entity that must be destroyed.
----

----
--- @class PlaceAsTileResult
--- 
--- @field result LuaTilePrototype The tile prototype.
--- @field condition_size uint 
--- @field condition CollisionMask 
----

----
--- @alias PlayerIdentification LuaPlayer|uint|string
--- A player may be specified in one of three ways.
----

----
--- @class PollutionMapSettings
--- These values are for the time frame of one second (60 ticks).
--- 
--- @field enabled boolean Whether pollution is enabled at all.
--- @field diffusion_ratio double The amount that is diffused to a neighboring chunk (possibly repeated for other directions as well). Defaults to `0.02`.
--- @field min_to_diffuse double The amount of PUs that need to be in a chunk for it to start diffusing. Defaults to `15`.
--- @field ageing double The amount of pollution eaten by a chunk's tiles as a percentage of 1. Defaults to `1`.
--- @field expected_max_per_chunk double Any amount of pollution larger than this value is visualized as this value instead. Defaults to `150`.
--- @field min_to_show_per_chunk double Any amount of pollution smaller than this value (but bigger than zero) is visualized as this value instead. Defaults to `50`.
--- @field min_pollution_to_damage_trees double Defaults to `60`.
--- @field pollution_with_max_forest_damage double Defaults to `150`.
--- @field pollution_per_tree_damage double Defaults to `50`.
--- @field pollution_restored_per_tree_damage double Defaults to `10`.
--- @field max_pollution_to_restore_trees double Defaults to `20`.
--- @field enemy_attack_pollution_consumption_modifier double Defaults to `1`.
----

----
--- @class Product
--- 
--- @field type string `"item"` or `"fluid"`.
--- @field name string Prototype name of the result.
--- @field amount double? Amount of the item or fluid to give. If not specified, `amount_min`, `amount_max` and `probability` must all be specified.
--- @field amount_min double|uint? Minimal amount of the item or fluid to give. Has no effect when `amount` is specified.
--- @field amount_max double|uint? Maximum amount of the item or fluid to give. Has no effect when `amount` is specified.
--- @field probability double? A value in range [0, 1]. Item or fluid is only given with this probability; otherwise no product is produced.
--- @field catalyst_amount double|uint? How much of this product is a catalyst.
----

----
--- @class ProgrammableSpeakerAlertParameters
--- 
--- @field show_alert boolean 
--- @field show_on_map boolean 
--- @field icon_signal_id SignalID 
--- @field alert_message string 
----

----
--- @class ProgrammableSpeakerCircuitParameters
--- 
--- @field signal_value_is_pitch boolean 
--- @field instrument_id uint 
--- @field note_id uint 
----

----
--- @class ProgrammableSpeakerInstrument
--- 
--- @field name string 
--- @field notes string[] 
----

----
--- @class ProgrammableSpeakerParameters
--- 
--- @field playback_volume double 
--- @field playback_globally boolean 
--- @field allow_polyphony boolean 
----

----
--- @alias PrototypeFilter ItemPrototypeFilter|TilePrototypeFilter|RecipePrototypeFilter|AchievementPrototypeFilter|EquipmentPrototypeFilter|DecorativePrototypeFilter|TechnologyPrototypeFilter|EntityPrototypeFilter|FluidPrototypeFilter[]
--- Types `"signal"` and `"item-group"` do not support filters.
----

----
--- @class PrototypeHistory
--- 
--- @field created string The mod that created this prototype.
--- @field changed string[] The mods that changed this prototype in the order they changed it.
----

----
--- @alias RealOrientation float
--- The smooth orientation. It is a [float](float) in the range `[0, 1)` that covers a full circle, starting at the top and going clockwise. This means a value of `0` indicates "north", a value of `0.5` indicates "south".
--- 
--- For example then, a value of `0.625` would indicate "south-west", and a value of `0.875` would indicate "north-west".
----

----
--- @class RecipePrototypeFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"enabled"`, `"hidden"`, `"hidden-from-flow-stats"`, `"hidden-from-player-crafting"`, `"allow-as-intermediate"`, `"allow-intermediates"`, `"allow-decomposition"`, `"always-show-made-in"`, `"always-show-products"`, `"show-amount-in-title"`, `"has-ingredients"`, `"has-products"`, `"has-ingredient-item"`, `"has-ingredient-fluid"`, `"has-product-item"`, `"has-product-fluid"`, `"subgroup"`, `"category"`, `"energy"`, `"emissions-multiplier"`, `"request-paste-multiplier"`, `"overload-multiplier"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @alias RenderLayer string
--- A number between 0 and 255 inclusive, represented by one of the following named strings or the string version of the number. For example `"27"` and `"decals"` are both valid. Higher values are rendered above lower values.
----

----
--- @class Resistance
--- 
--- @field decrease float Absolute damage decrease
--- @field percent float Percentual damage decrease
----

----
--- @class RidingState
--- 
--- @field acceleration defines.riding.acceleration 
--- @field direction defines.riding.direction 
----

----
--- @class ScriptArea
--- An area defined using the map editor.
--- 
--- @field area BoundingBox 
--- @field name string 
--- @field color Color 
--- @field id uint 
----

----
--- @class ScriptPosition
--- A position defined using the map editor.
--- 
--- @field position MapPosition 
--- @field name string 
--- @field color Color 
--- @field id uint 
----

----
--- @class ScriptRenderTarget
--- 
--- @field entity LuaEntity? 
--- @field entity_offset Vector? 
--- @field position MapPosition? 
----

----
--- @class ScriptRenderVertexTarget
--- One vertex of a ScriptRenderPolygon.
--- 
--- @field target LuaEntity|MapPosition 
--- @field target_offset Vector? Only used if `target` is a LuaEntity.
----

----
--- @class SelectedPrototypeData
--- 
--- @field base_type string E.g. `"entity"`.
--- @field derived_type string E.g. `"tree"`.
--- @field name string E.g. `"tree-05"`.
----

----
--- @class SelectionModeFlags
--- A set of flags on a selection tool that define how entities and tiles are selected. Active flags are in the dictionary as `true`, while inactive flags aren't present at all.
--- 
--- @field blueprint bool Selects entities and tiles as if selecting them for a blueprint.
--- @field deconstruct bool Selects entities and tiles as if selecting them for deconstruction.
--- @field cancel-deconstruct bool Selects entities and tiles as if selecting them for deconstruction cancellation.
--- @field items bool Selects items on the ground.
--- @field trees bool Selects trees.
--- @field buildable-type bool Selects entities which are considered a [building](LuaEntityPrototype::is_building), plus landmines.
--- @field nothing bool Selects no entities or tiles, but is useful to select an area.
--- @field items-to-place bool Selects entities and tiles that can be [built by an item](LuaItemPrototype::place_result).
--- @field any-entity bool Selects all entities.
--- @field any-tile bool Selects all tiles.
--- @field same-force bool Selects entities with the same force as the selecting player.
--- @field not-same-force bool Selects entities with a different force as the selecting player.
--- @field friend bool Selects entities from a [friendly](LuaForce::is_friend) force.
--- @field enemy bool Selects entities from an [enemy](LuaForce::is_enemy) force.
--- @field upgrade bool Selects entities as if selecting them for upgrading.
--- @field cancel-upgrade bool Selects entities as if selecting them for upgrade cancellation.
--- @field downgrade bool Selects entities as if selecting them for downgrading.
--- @field entity-with-health bool Selects entities that are [entities with health](LuaEntity::is_entity_with_health).
--- @field entity-with-force bool Deprecated. Replaced by `is-military-target`.
--- @field is-military-target bool Selects entities that are [military targets](LuaEntity::is_military_target).
--- @field entity-with-owner bool Selects entities that are [entities with owner](LuaEntity::is_entity_with_owner).
--- @field avoid-rolling-stock bool Selects entities that are not `rolling-stock`s.
--- @field entity-ghost bool Selects entities that are `entity-ghost`s.
--- @field tile-ghost bool Selects entities that are `tile-ghost`s.
----

----
--- @class Signal
--- An actual signal transmitted by the network.
--- 
--- @field signal SignalID ID of the signal.
--- @field count int Value of the signal.
----

----
--- @class SignalID
--- 
--- @field type string `"item"`, `"fluid"`, or `"virtual"`.
--- @field name string? Name of the item, fluid or virtual signal.
----

----
--- @alias SimpleItemStack ItemStackDefinition|string
--- An item stack may be specified in one of two ways.
----

----
--- @class SmokeSource
--- 
--- @field name string 
--- @field frequency double 
--- @field offset double 
--- @field position Vector? 
--- @field north_position Vector? 
--- @field east_position Vector? 
--- @field south_position Vector? 
--- @field west_position Vector? 
--- @field deviation MapPosition? 
--- @field starting_frame_speed uint16 
--- @field starting_frame_speed_deviation double 
--- @field starting_frame uint16 
--- @field starting_frame_deviation double 
--- @field slow_down_factor uint8 
--- @field height float 
--- @field height_deviation float 
--- @field starting_vertical_speed float 
--- @field starting_vertical_speed_deviation float 
--- @field vertical_speed_slowdown float 
----

----
--- @alias SoundPath string
--- It can be either the name of a [sound prototype](https://wiki.factorio.com/Prototype/Sound) defined in the data stage, or a path in the form `"type/name"`. The latter option can be sorted into three categories.
--- 
--- The validity of a SoundPath can be verified at runtime using [LuaGameScript::is_valid_sound_path](LuaGameScript::is_valid_sound_path).
--- 
--- The utility and ambient types each contain general use sound prototypes defined by the game itself.
--- - `"utility"` - Uses the [UtilitySounds](https://wiki.factorio.com/Prototype/UtilitySounds) prototype. Example: `"utility/wire_connect_pole"`
--- - `"ambient"` - Uses [AmbientSound](https://wiki.factorio.com/Prototype/AmbientSound) prototypes. Example: `"ambient/resource-deficiency"`
--- 
--- The following types can be combined with any tile name as long as its prototype defines the
---     corresponding sound.
--- - `"tile-walking"` - Uses [Tile::walking_sound](https://wiki.factorio.com/Prototype/Tile#walking_sound). Example: `"tile-walking/concrete"`
--- - `"tile-mined"` - Uses [Tile::mined_sound](https://wiki.factorio.com/Prototype/Tile#mined_sound)
--- - `"tile-build-small"` - Uses [Tile::build_sound](https://wiki.factorio.com/Prototype/Tile#build_sound). Example: `"tile-build-small/concrete"`
--- - `"tile-build-medium"` - Uses [Tile::build_sound](https://wiki.factorio.com/Prototype/Tile#build_sound)
--- - `"tile-build-large"` - Uses [Tile::build_sound](https://wiki.factorio.com/Prototype/Tile#build_sound)
--- 
--- The following types can be combined with any entity name as long as its prototype defines the
---     corresponding sound.
--- - `"entity-build"` - Uses [Entity::build_sound](https://wiki.factorio.com/Prototype/Entity#build_sound). Example: `"entity-build/wooden-chest"`
--- - `"entity-mined"` - Uses [Entity::mined_sound](https://wiki.factorio.com/Prototype/Entity#mined_sound)
--- - `"entity-mining"` - Uses [Entity::mining_sound](https://wiki.factorio.com/Prototype/Entity#mining_sound)
--- - `"entity-vehicle_impact"` - Uses [Entity::vehicle_impact_sound](https://wiki.factorio.com/Prototype/Entity#vehicle_impact_sound)
--- - `"entity-rotated"` - Uses [Entity::rotated_sound](https://wiki.factorio.com/Prototype/Entity#rotated_sound)
--- - `"entity-open"` - Uses [Entity::open_sound](https://wiki.factorio.com/Prototype/Entity#open_sound)
--- - `"entity-close"` - Uses [Entity::close_sound](https://wiki.factorio.com/Prototype/Entity#close_sound)
----

----
--- @alias SoundType string
--- Defines which slider in the game's sound settings affects the volume of this sound. Furthermore, some sound types are mixed differently than others, e.g. zoom level effects are applied.
----

----
--- @class SpawnPointDefinition
--- 
--- @field evolution_factor double Evolution factor for which this weight applies.
--- @field weight double Probability of spawning this unit at this evolution factor.
----

----
--- @alias SpritePath string
--- It can be either the name of a [sprite prototype](https://wiki.factorio.com/Prototype/Sprite) defined in the data stage, or a path in form "type/name".
--- 
--- The validity of a SpritePath can be verified at runtime using [LuaGameScript::is_valid_sprite_path](LuaGameScript::is_valid_sprite_path).
--- 
--- The supported types are:
--- - `"item"` - for example "item/iron-plate" is the icon sprite of iron plate
--- - `"entity"` - for example "entity/small-biter" is the icon sprite of the small biter
--- - `"technology"`
--- - `"recipe"`
--- - `"item-group"`
--- - `"fluid"`
--- - `"tile"`
--- - `"virtual-signal"`
--- - `"achievement"`
--- - `"equipment"`
--- - `"file"` - path to an image file located inside the current scenario. This file is not preloaded so it will be slower; for frequently used sprites, it is better to define sprite prototype and use it instead.
--- - `"utility"` - sprite defined in the utility-sprites object, these are the pictures used by the game internally for the UI.
----

----
--- @class SteeringMapSetting
--- 
--- @field radius double Does not include the radius of the unit.
--- @field separation_factor double 
--- @field separation_force double 
--- @field force_unit_fuzzy_goto_behavior boolean Used to make steering look better for aesthetic purposes.
----

----
--- @class SteeringMapSettings
--- 
--- @field default SteeringMapSetting 
--- @field moving SteeringMapSetting 
----

----
--- @alias SurfaceIdentification uint|LuaSurface|string
--- A surface may be specified in one of three ways.
----

----
--- @class TabAndContent
--- 
--- @field tab LuaGuiElement 
--- @field content LuaGuiElement 
----

----
--- @alias Tags table<string,AnyBasic>
--- A dictionary of string to the four basic Lua types: `string`, `boolean`, `number`, `table`.
--- 
--- Note that the API returns tags as a simple table, meaning any modifications to it will not propagate back to the game. Thus, to modify a set of tags, the whole table needs to be written back to the respective property.
----

----
--- @alias TechnologyIdentification LuaTechnologyPrototype|LuaTechnology|string
--- A technology may be specified in one of three ways.
----

----
--- @class TechnologyModifier
--- The effect that is applied when a technology is researched. It is a table that contains at least the field `type`.
--- 
--- @field type string Modifier type. Specifies which of the other fields will be available. Possible values are: `"inserter-stack-size-bonus"`, `"stack-inserter-capacity-bonus"`, `"laboratory-speed"`, `"character-logistic-trash-slots"`, `"maximum-following-robots-count"`, `"worker-robot-speed"`, `"worker-robot-storage"`, `"ghost-time-to-live"`, `"turret-attack"`, `"ammo-damage"`, `"give-item"`, `"gun-speed"`, `"unlock-recipe"`, `"character-crafting-speed"`, `"character-mining-speed"`, `"character-running-speed"`, `"character-build-distance"`, `"character-item-drop-distance"`, `"character-reach-distance"`, `"character-resource-reach-distance"`, `"character-item-pickup-distance"`, `"character-loot-pickup-distance"`, `"character-inventory-slots-bonus"`, `"deconstruction-time-to-live"`, `"max-failed-attempts-per-tick-per-construction-queue"`, `"max-successful-attempts-per-tick-per-construction-queue"`, `"character-health-bonus"`, `"mining-drill-productivity-bonus"`, `"train-braking-force-bonus"`, `"zoom-to-world-enabled"`, `"zoom-to-world-ghost-building-enabled"`, `"zoom-to-world-blueprint-enabled"`, `"zoom-to-world-deconstruction-planner-enabled"`, `"zoom-to-world-upgrade-planner-enabled"`, `"zoom-to-world-selection-tool-enabled"`, `"worker-robot-battery"`, `"laboratory-productivity"`, `"follower-robot-lifetime"`, `"artillery-range"`, `"nothing"`, `"character-additional-mining-categories"`, `"character-logistic-requests"`.
----

----
--- @class TechnologyPrototypeFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"enabled"`, `"hidden"`, `"upgrade"`, `"visible-when-disabled"`, `"has-effects"`, `"has-prerequisites"`, `"research-unit-ingredient"`, `"unlocks-recipe"`, `"level"`, `"max-level"`, `"time"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class Tile
--- 
--- @field position TilePosition The position of the tile.
--- @field name string The prototype name of the tile.
----

----
--- @alias TilePosition { x: int, y: int }
--- Coordinates of a tile on a [LuaSurface](LuaSurface) where each integer `x`/`y` represents a different tile. This uses the same format as [MapPosition](MapPosition), except it rounds any non-integer `x`/`y` down to whole numbers. It can be specified either with or without explicit keys.
----

----
--- @class TilePrototypeFilter
--- Depending on the value of `filter`, the table may take additional fields. `filter` may be one of the following:
--- 
--- @field filter string The condition to filter on. One of `"minable"`, `"autoplace"`, `"blueprintable"`, `"item-to-place"`, `"collision-mask"`, `"walking-speed-modifier"`, `"vehicle-friction-modifier"`, `"decorative-removal-probability"`, `"emissions"`.
--- @field mode string? How to combine this with the previous filter. Must be `"or"` or `"and"`. Defaults to `"or"`. When evaluating the filters, `"and"` has higher precedence than `"or"`.
--- @field invert boolean? Inverts the condition. Default is `false`.
----

----
--- @class TrainSchedule
--- 
--- @field current uint Index of the currently active record
--- @field records TrainScheduleRecord[] 
----

----
--- @class TrainScheduleRecord
--- 
--- @field station string? Name of the station.
--- @field rail LuaEntity? Rail to path to. Ignored if `station` is present.
--- @field rail_direction defines.rail_direction? When a train is allowed to reach rail target from any direction it will be `nil`. If rail has to be reached from specific direction, this value allows to choose the direction. This value corresponds to [LuaEntity::connected_rail_direction](LuaEntity::connected_rail_direction) of a TrainStop.
--- @field wait_conditions WaitCondition[]? 
--- @field temporary boolean? Only present when the station is temporary, the value is then always `true`.
----

----
--- @class TriggerDelivery
--- 
--- @field type string One of `"instant"`, `"projectile"`, `"flame-thrower"`, `"beam"`, `"stream"`, `"artillery"`.
--- @field source_effects TriggerEffectItem[] 
--- @field target_effects TriggerEffectItem[] 
----

----
--- @class TriggerEffectItem
--- 
--- @field type string One of`"damage"`, `"create-entity"`, `"create-explosion"`, `"create-fire"`, `"create-smoke"`, `"create-trivial-smoke"`, `"create-particle"`, `"create-sticker"`, `"nested-result"`, `"play-sound"`, `"push-back"`, `"destroy-cliffs"`, `"show-explosion-on-chart"`, `"insert-item"`, `"script"`.
--- @field repeat_count uint 
--- @field affects_target boolean 
--- @field show_in_tooltip boolean 
----

----
--- @class TriggerItem
--- 
--- @field type string One of `"direct"`, `"area"`, `"line"`, `"cluster"`.
--- @field action_delivery TriggerDelivery[]? 
--- @field entity_flags EntityPrototypeFlags? The trigger will only affect entities that contain any of these flags.
--- @field ignore_collision_condition boolean 
--- @field collision_mask CollisionMask The trigger will only affect entities that would collide with given collision mask.
--- @field trigger_target_mask TriggerTargetMask 
--- @field force ForceCondition If `"enemy"`, the trigger will only affect entities whose force is different from the attacker's and for which there is no cease-fire set. `"ally"` is the opposite of `"enemy"`.
--- @field repeat_count uint 
----

----
--- @alias TriggerTargetMask table<string,boolean>
--- A set of trigger target masks.
----

----
--- @class UnitGroupMapSettings
--- 
--- @field min_group_gathering_time uint The minimum amount of time in ticks a group will spend gathering before setting off. The actual time is a random time between the minimum and maximum times. Defaults to `3,600` ticks.
--- @field max_group_gathering_time uint The maximum amount of time in ticks a group will spend gathering before setting off. The actual time is a random time between the minimum and maximum times. Defaults to `10*3,600=36,000` ticks.
--- @field max_wait_time_for_late_members uint After gathering has finished, the group is allowed to wait this long in ticks for delayed members. New members are not accepted anymore however. Defaults to `2*3,600=7,200` ticks.
--- @field min_group_radius double The minimum group radius in tiles. The actual radius is adjusted based on the number of members. Defaults to `5.0`.
--- @field max_group_radius double The maximum group radius in tiles. The actual radius is adjusted based on the number of members. Defaults to `30.0`.
--- @field max_member_speedup_when_behind double The maximum speed a percentage of its regular speed that a group member can speed up to when catching up with the group. Defaults to `1.4`, or 140%.
--- @field max_member_slowdown_when_ahead double The minimum speed a percentage of its regular speed that a group member can slow down to when ahead of the group. Defaults to `0.6`, or 60%.
--- @field max_group_slowdown_factor double The minimum speed as a percentage of its maximum speed that a group will slow down to so members that fell behind can catch up. Defaults to `0.3`, or 30%.
--- @field max_group_member_fallback_factor double When a member of a group falls back more than this factor times the group radius, the group will slow down to its `max_group_slowdown_factor` speed to let them catch up. Defaults to `3`.
--- @field member_disown_distance double When a member of a group falls back more than this factor times the group radius, it will be dropped from the group. Defaults to `10`.
--- @field tick_tolerance_when_member_arrives uint 
--- @field max_gathering_unit_groups uint The maximum number of automatically created unit groups gathering for attack at any time. Defaults to `30`.
--- @field max_unit_group_size uint The maximum number of members for an attack unit group. This only affects automatically created unit groups, manual groups created through the API are unaffected. Defaults to `200`.
----

----
--- @class UnitSpawnDefinition
--- 
--- @field unit string Prototype name of the unit that would be spawned.
--- @field spawn_points SpawnPointDefinition[] The points at which to spawn the unit.
----

----
--- @class UpgradeFilter
--- 
--- @field type string `"item"`, or `"entity"`.
--- @field name string? Name of the item, or entity.
----

----
--- @alias Vector { x: float, y: float }
--- A vector is a two-element array containing the `x` and `y` components. In some specific cases, the vector is a table with `x` and `y` keys instead, which the documentation will point out.
----

----
--- @class VehicleAutomaticTargetingParameters
--- 
--- @field auto_target_without_gunner boolean 
--- @field auto_target_with_gunner boolean 
----

----
--- @class WaitCondition
--- 
--- @field type string One of `"time"`, `"inactivity"`, `"full"`, `"empty"`, `"item_count"`, `"circuit"`, `"robots_inactive"`, `"fluid_count"`, `"passenger_present"`, `"passenger_not_present"`.
--- @field compare_type string Either `"and"`, or `"or"`. Tells how this condition is to be compared with the preceding conditions in the corresponding `wait_conditions` array.
--- @field ticks uint? Number of ticks to wait when `type` is `"time"`, or number of ticks of inactivity when `type` is `"inactivity"`.
--- @field condition CircuitCondition? Only present when `type` is `"item_count"`, `"circuit"` or `"fluid_count"`, and a circuit condition is configured.
----

----
--- @class WireConnectionDefinition
--- 
--- @field wire defines.wire_type The type of wire used.
--- @field target_entity LuaEntity The entity to (dis)connect the source entity with.
--- @field source_circuit_id defines.circuit_connector_id? Mandatory if the source entity has more than one circuit connection using circuit wire.
--- @field target_circuit_id defines.circuit_connector_id? Mandatory if the target entity has more than one circuit connection using circuit wire.
--- @field source_wire_id defines.wire_connection_id? Mandatory if the source entity has more than one wire connection using copper wire.
--- @field target_wire_id defines.wire_connection_id? Mandatory if the target entity has more than one wire connection using copper wire.
----



