
--- @module
defines = { }

----
--- @class defines.alert_type: int
--- 
--- @field entity_destroyed defines.alert_type 
--- @field entity_under_attack defines.alert_type 
--- @field not_enough_construction_robots defines.alert_type 
--- @field no_material_for_construction defines.alert_type 
--- @field not_enough_repair_packs defines.alert_type 
--- @field turret_fire defines.alert_type 
--- @field custom defines.alert_type 
--- @field no_storage defines.alert_type 
--- @field train_out_of_fuel defines.alert_type 
----
defines.alert_type = { }

defines.alert_type.entity_destroyed = 0
defines.alert_type.entity_under_attack = 1
defines.alert_type.not_enough_construction_robots = 2
defines.alert_type.no_material_for_construction = 3
defines.alert_type.not_enough_repair_packs = 4
defines.alert_type.turret_fire = 5
defines.alert_type.custom = 6
defines.alert_type.no_storage = 7
defines.alert_type.train_out_of_fuel = 8

----
--- @class defines.behavior_result: int
--- AI command exit status. See [LuaEntity::set_command](LuaEntity::set_command)
--- 
--- @field in_progress defines.behavior_result 
--- @field fail defines.behavior_result 
--- @field success defines.behavior_result 
--- @field deleted defines.behavior_result 
----
defines.behavior_result = { }

defines.behavior_result.in_progress = 0
defines.behavior_result.fail = 1
defines.behavior_result.success = 2
defines.behavior_result.deleted = 3

----
--- @class defines.build_check_type: int
--- 
--- @field script defines.build_check_type 
--- @field manual defines.build_check_type 
--- @field manual_ghost defines.build_check_type 
--- @field script_ghost defines.build_check_type 
--- @field blueprint_ghost defines.build_check_type 
--- @field ghost_revive defines.build_check_type 
----
defines.build_check_type = { }

defines.build_check_type.script = 0
defines.build_check_type.manual = 1
defines.build_check_type.manual_ghost = 2
defines.build_check_type.script_ghost = 3
defines.build_check_type.blueprint_ghost = 4
defines.build_check_type.ghost_revive = 5

----
--- @class defines.chain_signal_state: int
--- State of a chain signal.
--- 
--- @field none defines.chain_signal_state 
--- @field all_open defines.chain_signal_state 
--- @field partially_open defines.chain_signal_state 
--- @field none_open defines.chain_signal_state 
----
defines.chain_signal_state = { }

defines.chain_signal_state.none = 0
defines.chain_signal_state.all_open = 1
defines.chain_signal_state.partially_open = 2
defines.chain_signal_state.none_open = 3

----
--- @class defines.chunk_generated_status: int
--- 
--- @field nothing defines.chunk_generated_status 
--- @field custom_tiles defines.chunk_generated_status 
--- @field basic_tiles defines.chunk_generated_status 
--- @field corrected_tiles defines.chunk_generated_status 
--- @field tiles defines.chunk_generated_status 
--- @field entities defines.chunk_generated_status 
----
defines.chunk_generated_status = { }

defines.chunk_generated_status.nothing = 0
defines.chunk_generated_status.custom_tiles = 1
defines.chunk_generated_status.basic_tiles = 2
defines.chunk_generated_status.corrected_tiles = 3
defines.chunk_generated_status.tiles = 4
defines.chunk_generated_status.entities = 5

----
--- @class defines.circuit_condition_index: int
--- 
--- @field inserter_circuit defines.circuit_condition_index 
--- @field inserter_logistic defines.circuit_condition_index 
--- @field lamp defines.circuit_condition_index 
--- @field arithmetic_combinator defines.circuit_condition_index 
--- @field decider_combinator defines.circuit_condition_index 
--- @field constant_combinator defines.circuit_condition_index 
--- @field offshore_pump defines.circuit_condition_index 
--- @field pump defines.circuit_condition_index 
----
defines.circuit_condition_index = { }

defines.circuit_condition_index.inserter_circuit = 0
defines.circuit_condition_index.inserter_logistic = 1
defines.circuit_condition_index.lamp = 2
defines.circuit_condition_index.arithmetic_combinator = 3
defines.circuit_condition_index.decider_combinator = 4
defines.circuit_condition_index.constant_combinator = 5
defines.circuit_condition_index.offshore_pump = 6
defines.circuit_condition_index.pump = 7

----
--- @class defines.circuit_connector_id: int
--- 
--- @field accumulator defines.circuit_connector_id 
--- @field constant_combinator defines.circuit_connector_id 
--- @field container defines.circuit_connector_id 
--- @field linked_container defines.circuit_connector_id 
--- @field programmable_speaker defines.circuit_connector_id 
--- @field rail_signal defines.circuit_connector_id 
--- @field rail_chain_signal defines.circuit_connector_id 
--- @field roboport defines.circuit_connector_id 
--- @field storage_tank defines.circuit_connector_id 
--- @field wall defines.circuit_connector_id 
--- @field electric_pole defines.circuit_connector_id 
--- @field inserter defines.circuit_connector_id 
--- @field lamp defines.circuit_connector_id 
--- @field combinator_input defines.circuit_connector_id 
--- @field combinator_output defines.circuit_connector_id 
--- @field offshore_pump defines.circuit_connector_id 
--- @field pump defines.circuit_connector_id 
----
defines.circuit_connector_id = { }

defines.circuit_connector_id.accumulator = 0
defines.circuit_connector_id.constant_combinator = 1
defines.circuit_connector_id.container = 2
defines.circuit_connector_id.linked_container = 3
defines.circuit_connector_id.programmable_speaker = 4
defines.circuit_connector_id.rail_signal = 5
defines.circuit_connector_id.rail_chain_signal = 6
defines.circuit_connector_id.roboport = 7
defines.circuit_connector_id.storage_tank = 8
defines.circuit_connector_id.wall = 9
defines.circuit_connector_id.electric_pole = 10
defines.circuit_connector_id.inserter = 11
defines.circuit_connector_id.lamp = 12
defines.circuit_connector_id.combinator_input = 13
defines.circuit_connector_id.combinator_output = 14
defines.circuit_connector_id.offshore_pump = 15
defines.circuit_connector_id.pump = 16

----
--- @class defines.command: int
--- Command given to units describing what they should do.
--- 
--- @field attack defines.command Attack another entity.
--- @field go_to_location defines.command Go to a specific position.
--- @field compound defines.command Chain commands together, see [defines.compound_command](defines.compound_command).
--- @field group defines.command Do what your group wants you to do.
--- @field attack_area defines.command Go to a place and attack what you see.
--- @field wander defines.command Chill.
--- @field flee defines.command Flee from another entity.
--- @field stop defines.command Stop moving and stay where you are.
--- @field build_base defines.command Go to a position and build a base there.
----
defines.command = { }

defines.command.attack = 0
defines.command.go_to_location = 1
defines.command.compound = 2
defines.command.group = 3
defines.command.attack_area = 4
defines.command.wander = 5
defines.command.flee = 6
defines.command.stop = 7
defines.command.build_base = 8

----
--- @class defines.compound_command: int
--- How commands are joined together in a compound command (see [defines.command.compound](defines.command.compound)).
--- 
--- @field logical_and defines.compound_command Fail on first failure. Only succeeds if all commands (executed one after another) succeed.
--- @field logical_or defines.compound_command Succeed on first success. Only fails if all commands (executed one after another) fail.
--- @field return_last defines.compound_command Execute all commands in sequence and fail or succeed depending on the return status of the last command.
----
defines.compound_command = { }

defines.compound_command.logical_and = 0
defines.compound_command.logical_or = 1
defines.compound_command.return_last = 2

----
--- @class defines.control_behavior: int
--- 
--- @field inserter defines.control_behavior.inserter 
--- @field logistic_container defines.control_behavior.logistic_container 
--- @field lamp defines.control_behavior.lamp 
--- @field mining_drill defines.control_behavior.mining_drill 
--- @field transport_belt defines.control_behavior.transport_belt 
--- @field type defines.control_behavior.type 
----
defines.control_behavior = { }

----
--- @class defines.control_behavior.inserter: int
--- 
--- @field circuit_mode_of_operation defines.control_behavior.inserter.circuit_mode_of_operation 
--- @field hand_read_mode defines.control_behavior.inserter.hand_read_mode 
----
defines.control_behavior.inserter = { }

----
--- @class defines.control_behavior.inserter.circuit_mode_of_operation: int
--- 
--- @field none defines.control_behavior.inserter.circuit_mode_of_operation 
--- @field enable_disable defines.control_behavior.inserter.circuit_mode_of_operation 
--- @field set_filters defines.control_behavior.inserter.circuit_mode_of_operation 
--- @field read_hand_contents defines.control_behavior.inserter.circuit_mode_of_operation 
--- @field set_stack_size defines.control_behavior.inserter.circuit_mode_of_operation 
----
defines.control_behavior.inserter.circuit_mode_of_operation = { }

defines.control_behavior.inserter.circuit_mode_of_operation.none = 0
defines.control_behavior.inserter.circuit_mode_of_operation.enable_disable = 1
defines.control_behavior.inserter.circuit_mode_of_operation.set_filters = 2
defines.control_behavior.inserter.circuit_mode_of_operation.read_hand_contents = 3
defines.control_behavior.inserter.circuit_mode_of_operation.set_stack_size = 4

----
--- @class defines.control_behavior.inserter.hand_read_mode: int
--- 
--- @field hold defines.control_behavior.inserter.hand_read_mode 
--- @field pulse defines.control_behavior.inserter.hand_read_mode 
----
defines.control_behavior.inserter.hand_read_mode = { }

defines.control_behavior.inserter.hand_read_mode.hold = 0
defines.control_behavior.inserter.hand_read_mode.pulse = 1


----
--- @class defines.control_behavior.lamp: int
--- 
--- @field circuit_mode_of_operation defines.control_behavior.lamp.circuit_mode_of_operation 
----
defines.control_behavior.lamp = { }

----
--- @class defines.control_behavior.lamp.circuit_mode_of_operation: int
--- 
--- @field use_colors defines.control_behavior.lamp.circuit_mode_of_operation 
----
defines.control_behavior.lamp.circuit_mode_of_operation = { }

defines.control_behavior.lamp.circuit_mode_of_operation.use_colors = 0


----
--- @class defines.control_behavior.logistic_container: int
--- 
--- @field circuit_mode_of_operation defines.control_behavior.logistic_container.circuit_mode_of_operation 
----
defines.control_behavior.logistic_container = { }

----
--- @class defines.control_behavior.logistic_container.circuit_mode_of_operation: int
--- 
--- @field send_contents defines.control_behavior.logistic_container.circuit_mode_of_operation 
--- @field set_requests defines.control_behavior.logistic_container.circuit_mode_of_operation 
----
defines.control_behavior.logistic_container.circuit_mode_of_operation = { }

defines.control_behavior.logistic_container.circuit_mode_of_operation.send_contents = 0
defines.control_behavior.logistic_container.circuit_mode_of_operation.set_requests = 1


----
--- @class defines.control_behavior.mining_drill: int
--- 
--- @field resource_read_mode defines.control_behavior.mining_drill.resource_read_mode 
----
defines.control_behavior.mining_drill = { }

----
--- @class defines.control_behavior.mining_drill.resource_read_mode: int
--- 
--- @field this_miner defines.control_behavior.mining_drill.resource_read_mode 
--- @field entire_patch defines.control_behavior.mining_drill.resource_read_mode 
----
defines.control_behavior.mining_drill.resource_read_mode = { }

defines.control_behavior.mining_drill.resource_read_mode.this_miner = 0
defines.control_behavior.mining_drill.resource_read_mode.entire_patch = 1


----
--- @class defines.control_behavior.transport_belt: int
--- 
--- @field content_read_mode defines.control_behavior.transport_belt.content_read_mode 
----
defines.control_behavior.transport_belt = { }

----
--- @class defines.control_behavior.transport_belt.content_read_mode: int
--- 
--- @field pulse defines.control_behavior.transport_belt.content_read_mode 
--- @field hold defines.control_behavior.transport_belt.content_read_mode 
----
defines.control_behavior.transport_belt.content_read_mode = { }

defines.control_behavior.transport_belt.content_read_mode.pulse = 0
defines.control_behavior.transport_belt.content_read_mode.hold = 1


----
--- @class defines.control_behavior.type: int
--- 
--- @field container defines.control_behavior.type [LuaContainerControlBehavior](LuaContainerControlBehavior)
--- @field generic_on_off defines.control_behavior.type [LuaGenericOnOffControlBehavior](LuaGenericOnOffControlBehavior)
--- @field inserter defines.control_behavior.type [LuaInserterControlBehavior](LuaInserterControlBehavior)
--- @field lamp defines.control_behavior.type [LuaLampControlBehavior](LuaLampControlBehavior)
--- @field logistic_container defines.control_behavior.type [LuaLogisticContainerControlBehavior](LuaLogisticContainerControlBehavior)
--- @field roboport defines.control_behavior.type [LuaRoboportControlBehavior](LuaRoboportControlBehavior)
--- @field storage_tank defines.control_behavior.type [LuaStorageTankControlBehavior](LuaStorageTankControlBehavior)
--- @field train_stop defines.control_behavior.type [LuaTrainStopControlBehavior](LuaTrainStopControlBehavior)
--- @field decider_combinator defines.control_behavior.type [LuaDeciderCombinatorControlBehavior](LuaDeciderCombinatorControlBehavior)
--- @field arithmetic_combinator defines.control_behavior.type [LuaArithmeticCombinatorControlBehavior](LuaArithmeticCombinatorControlBehavior)
--- @field constant_combinator defines.control_behavior.type [LuaConstantCombinatorControlBehavior](LuaConstantCombinatorControlBehavior)
--- @field transport_belt defines.control_behavior.type [LuaTransportBeltControlBehavior](LuaTransportBeltControlBehavior)
--- @field accumulator defines.control_behavior.type [LuaAccumulatorControlBehavior](LuaAccumulatorControlBehavior)
--- @field rail_signal defines.control_behavior.type [LuaRailSignalControlBehavior](LuaRailSignalControlBehavior)
--- @field rail_chain_signal defines.control_behavior.type [LuaRailChainSignalControlBehavior](LuaRailChainSignalControlBehavior)
--- @field wall defines.control_behavior.type [LuaWallControlBehavior](LuaWallControlBehavior)
--- @field mining_drill defines.control_behavior.type [LuaMiningDrillControlBehavior](LuaMiningDrillControlBehavior)
--- @field programmable_speaker defines.control_behavior.type [LuaProgrammableSpeakerControlBehavior](LuaProgrammableSpeakerControlBehavior)
----
defines.control_behavior.type = { }

defines.control_behavior.type.container = 0
defines.control_behavior.type.generic_on_off = 1
defines.control_behavior.type.inserter = 2
defines.control_behavior.type.lamp = 3
defines.control_behavior.type.logistic_container = 4
defines.control_behavior.type.roboport = 5
defines.control_behavior.type.storage_tank = 6
defines.control_behavior.type.train_stop = 7
defines.control_behavior.type.decider_combinator = 8
defines.control_behavior.type.arithmetic_combinator = 9
defines.control_behavior.type.constant_combinator = 10
defines.control_behavior.type.transport_belt = 11
defines.control_behavior.type.accumulator = 12
defines.control_behavior.type.rail_signal = 13
defines.control_behavior.type.rail_chain_signal = 14
defines.control_behavior.type.wall = 15
defines.control_behavior.type.mining_drill = 16
defines.control_behavior.type.programmable_speaker = 17


----
--- @class defines.controllers: int
--- 
--- @field ghost defines.controllers Can't interact with the world, can only observe. Used in the multiplayer waiting-to-respawn screen.
--- @field character defines.controllers The controller controls a character. This is the default controller in freeplay.
--- @field god defines.controllers The controller isn't tied to a character. This is the default controller in sandbox.
--- @field editor defines.controllers The Editor Controller near ultimate power to do almost anything in the game.
--- @field cutscene defines.controllers The player can't interact with the world, and the camera pans around in a predefined manner.
--- @field spectator defines.controllers Can't change anything in the world but can view anything.
----
defines.controllers = { }

defines.controllers.ghost = 0
defines.controllers.character = 1
defines.controllers.god = 2
defines.controllers.editor = 3
defines.controllers.cutscene = 4
defines.controllers.spectator = 5

----
--- @class defines.deconstruction_item: int
--- 
--- @field entity_filter_mode defines.deconstruction_item.entity_filter_mode 
--- @field tile_filter_mode defines.deconstruction_item.tile_filter_mode 
--- @field tile_selection_mode defines.deconstruction_item.tile_selection_mode 
----
defines.deconstruction_item = { }

----
--- @class defines.deconstruction_item.entity_filter_mode: int
--- 
--- @field whitelist defines.deconstruction_item.entity_filter_mode 
--- @field blacklist defines.deconstruction_item.entity_filter_mode 
----
defines.deconstruction_item.entity_filter_mode = { }

defines.deconstruction_item.entity_filter_mode.whitelist = 0
defines.deconstruction_item.entity_filter_mode.blacklist = 1

----
--- @class defines.deconstruction_item.tile_filter_mode: int
--- 
--- @field whitelist defines.deconstruction_item.tile_filter_mode 
--- @field blacklist defines.deconstruction_item.tile_filter_mode 
----
defines.deconstruction_item.tile_filter_mode = { }

defines.deconstruction_item.tile_filter_mode.whitelist = 0
defines.deconstruction_item.tile_filter_mode.blacklist = 1

----
--- @class defines.deconstruction_item.tile_selection_mode: int
--- 
--- @field normal defines.deconstruction_item.tile_selection_mode 
--- @field always defines.deconstruction_item.tile_selection_mode 
--- @field never defines.deconstruction_item.tile_selection_mode 
--- @field only defines.deconstruction_item.tile_selection_mode 
----
defines.deconstruction_item.tile_selection_mode = { }

defines.deconstruction_item.tile_selection_mode.normal = 0
defines.deconstruction_item.tile_selection_mode.always = 1
defines.deconstruction_item.tile_selection_mode.never = 2
defines.deconstruction_item.tile_selection_mode.only = 3


----
--- @class defines.difficulty: int
--- 
--- @field easy defines.difficulty 
--- @field normal defines.difficulty 
--- @field hard defines.difficulty 
----
defines.difficulty = { }

defines.difficulty.easy = 0
defines.difficulty.normal = 1
defines.difficulty.hard = 2

----
--- @class defines.difficulty_settings: int
--- 
--- @field recipe_difficulty defines.difficulty_settings.recipe_difficulty 
--- @field technology_difficulty defines.difficulty_settings.technology_difficulty 
----
defines.difficulty_settings = { }

----
--- @class defines.difficulty_settings.recipe_difficulty: int
--- 
--- @field normal defines.difficulty_settings.recipe_difficulty 
--- @field expensive defines.difficulty_settings.recipe_difficulty 
----
defines.difficulty_settings.recipe_difficulty = { }

defines.difficulty_settings.recipe_difficulty.normal = 0
defines.difficulty_settings.recipe_difficulty.expensive = 1

----
--- @class defines.difficulty_settings.technology_difficulty: int
--- 
--- @field normal defines.difficulty_settings.technology_difficulty 
--- @field expensive defines.difficulty_settings.technology_difficulty 
----
defines.difficulty_settings.technology_difficulty = { }

defines.difficulty_settings.technology_difficulty.normal = 0
defines.difficulty_settings.technology_difficulty.expensive = 1


----
--- @class defines.direction: int
--- 
--- @field north defines.direction 
--- @field northeast defines.direction 
--- @field east defines.direction 
--- @field southeast defines.direction 
--- @field south defines.direction 
--- @field southwest defines.direction 
--- @field west defines.direction 
--- @field northwest defines.direction 
----
defines.direction = { }

defines.direction.north = 0
defines.direction.northeast = 1
defines.direction.east = 2
defines.direction.southeast = 3
defines.direction.south = 4
defines.direction.southwest = 5
defines.direction.west = 6
defines.direction.northwest = 7

----
--- @class defines.disconnect_reason: int
--- 
--- @field quit defines.disconnect_reason 
--- @field dropped defines.disconnect_reason 
--- @field reconnect defines.disconnect_reason 
--- @field wrong_input defines.disconnect_reason 
--- @field desync_limit_reached defines.disconnect_reason 
--- @field cannot_keep_up defines.disconnect_reason 
--- @field afk defines.disconnect_reason 
--- @field kicked defines.disconnect_reason 
--- @field kicked_and_deleted defines.disconnect_reason 
--- @field banned defines.disconnect_reason 
--- @field switching_servers defines.disconnect_reason 
----
defines.disconnect_reason = { }

defines.disconnect_reason.quit = 0
defines.disconnect_reason.dropped = 1
defines.disconnect_reason.reconnect = 2
defines.disconnect_reason.wrong_input = 3
defines.disconnect_reason.desync_limit_reached = 4
defines.disconnect_reason.cannot_keep_up = 5
defines.disconnect_reason.afk = 6
defines.disconnect_reason.kicked = 7
defines.disconnect_reason.kicked_and_deleted = 8
defines.disconnect_reason.banned = 9
defines.disconnect_reason.switching_servers = 10

----
--- @class defines.distraction: int
--- 
--- @field none defines.distraction Perform command even if someone attacks the unit.
--- @field by_enemy defines.distraction Attack closer enemy entities with force.
--- @field by_anything defines.distraction Attack closer enemy entities, including entities "built" by player (belts, inserters, chests).
--- @field by_damage defines.distraction Attack when attacked.
----
defines.distraction = { }

defines.distraction.none = 0
defines.distraction.by_enemy = 1
defines.distraction.by_anything = 2
defines.distraction.by_damage = 3

----
--- @class defines.entity_status: int
--- 
--- @field working defines.entity_status 
--- @field normal defines.entity_status 
--- @field no_power defines.entity_status 
--- @field low_power defines.entity_status 
--- @field no_fuel defines.entity_status 
--- @field disabled_by_control_behavior defines.entity_status 
--- @field opened_by_circuit_network defines.entity_status 
--- @field closed_by_circuit_network defines.entity_status 
--- @field disabled_by_script defines.entity_status 
--- @field marked_for_deconstruction defines.entity_status 
--- @field not_plugged_in_electric_network defines.entity_status Used by generators and solar panels.
--- @field networks_connected defines.entity_status Used by power switches.
--- @field networks_disconnected defines.entity_status Used by power switches.
--- @field charging defines.entity_status Used by accumulators.
--- @field discharging defines.entity_status Used by accumulators.
--- @field fully_charged defines.entity_status Used by accumulators.
--- @field out_of_logistic_network defines.entity_status Used by logistic containers.
--- @field no_recipe defines.entity_status Used by assembling machines.
--- @field no_ingredients defines.entity_status Used by furnaces.
--- @field no_input_fluid defines.entity_status Used by boilers, fluid turrets and fluid energy sources: Boiler has no fluid to work with.
--- @field no_research_in_progress defines.entity_status Used by labs.
--- @field no_minable_resources defines.entity_status Used by mining drills.
--- @field low_input_fluid defines.entity_status Used by boilers and fluid turrets: Boiler still has some fluid but is about to run out.
--- @field fluid_ingredient_shortage defines.entity_status Used by crafting machines.
--- @field full_output defines.entity_status Used by crafting machines, boilers, burner energy sources and reactors: Reactor/burner has full burnt result inventory, boiler has full output fluidbox.
--- @field item_ingredient_shortage defines.entity_status Used by crafting machines.
--- @field missing_required_fluid defines.entity_status Used by mining drills when the mining fluid is missing.
--- @field missing_science_packs defines.entity_status Used by labs.
--- @field waiting_for_source_items defines.entity_status Used by inserters.
--- @field waiting_for_space_in_destination defines.entity_status Used by inserters and mining drills.
--- @field preparing_rocket_for_launch defines.entity_status Used by the rocket silo.
--- @field waiting_to_launch_rocket defines.entity_status Used by the rocket silo.
--- @field launching_rocket defines.entity_status Used by the rocket silo.
--- @field no_modules_to_transmit defines.entity_status Used by beacons.
--- @field recharging_after_power_outage defines.entity_status Used by roboports.
--- @field waiting_for_target_to_be_built defines.entity_status Used by inserters targeting entity ghosts.
--- @field waiting_for_train defines.entity_status Used by inserters targeting rails.
--- @field no_ammo defines.entity_status Used by ammo turrets.
--- @field low_temperature defines.entity_status Used by heat energy sources.
--- @field disabled defines.entity_status Used by constant combinators: Combinator is turned off via switch in GUI.
--- @field turned_off_during_daytime defines.entity_status Used by lamps.
--- @field not_connected_to_rail defines.entity_status Used by rail signals.
--- @field cant_divide_segments defines.entity_status Used by rail signals.
----
defines.entity_status = { }

defines.entity_status.working = 0
defines.entity_status.normal = 1
defines.entity_status.no_power = 2
defines.entity_status.low_power = 3
defines.entity_status.no_fuel = 4
defines.entity_status.disabled_by_control_behavior = 5
defines.entity_status.opened_by_circuit_network = 6
defines.entity_status.closed_by_circuit_network = 7
defines.entity_status.disabled_by_script = 8
defines.entity_status.marked_for_deconstruction = 9
defines.entity_status.not_plugged_in_electric_network = 10
defines.entity_status.networks_connected = 11
defines.entity_status.networks_disconnected = 12
defines.entity_status.charging = 13
defines.entity_status.discharging = 14
defines.entity_status.fully_charged = 15
defines.entity_status.out_of_logistic_network = 16
defines.entity_status.no_recipe = 17
defines.entity_status.no_ingredients = 18
defines.entity_status.no_input_fluid = 19
defines.entity_status.no_research_in_progress = 20
defines.entity_status.no_minable_resources = 21
defines.entity_status.low_input_fluid = 22
defines.entity_status.fluid_ingredient_shortage = 23
defines.entity_status.full_output = 24
defines.entity_status.item_ingredient_shortage = 25
defines.entity_status.missing_required_fluid = 26
defines.entity_status.missing_science_packs = 27
defines.entity_status.waiting_for_source_items = 28
defines.entity_status.waiting_for_space_in_destination = 29
defines.entity_status.preparing_rocket_for_launch = 30
defines.entity_status.waiting_to_launch_rocket = 31
defines.entity_status.launching_rocket = 32
defines.entity_status.no_modules_to_transmit = 33
defines.entity_status.recharging_after_power_outage = 34
defines.entity_status.waiting_for_target_to_be_built = 35
defines.entity_status.waiting_for_train = 36
defines.entity_status.no_ammo = 37
defines.entity_status.low_temperature = 38
defines.entity_status.disabled = 39
defines.entity_status.turned_off_during_daytime = 40
defines.entity_status.not_connected_to_rail = 41
defines.entity_status.cant_divide_segments = 42

----
--- @class defines.events: int
--- See the [events page](events.html) for more info on what events contain and when they get raised.
--- 
--- @field on_tick defines.events 
--- @field on_gui_click defines.events 
--- @field on_gui_confirmed defines.events 
--- @field on_gui_text_changed defines.events 
--- @field on_gui_checked_state_changed defines.events 
--- @field on_entity_died defines.events 
--- @field on_post_entity_died defines.events 
--- @field on_entity_damaged defines.events 
--- @field on_picked_up_item defines.events 
--- @field on_built_entity defines.events 
--- @field on_sector_scanned defines.events 
--- @field on_player_mined_item defines.events 
--- @field on_pre_build defines.events 
--- @field on_rocket_launched defines.events 
--- @field on_pre_player_mined_item defines.events 
--- @field on_chunk_generated defines.events 
--- @field on_player_crafted_item defines.events 
--- @field on_robot_built_entity defines.events 
--- @field on_robot_pre_mined defines.events 
--- @field on_robot_mined defines.events 
--- @field on_research_started defines.events 
--- @field on_research_finished defines.events 
--- @field on_research_reversed defines.events 
--- @field on_research_cancelled defines.events 
--- @field on_player_rotated_entity defines.events 
--- @field on_marked_for_deconstruction defines.events 
--- @field on_cancelled_deconstruction defines.events 
--- @field on_trigger_created_entity defines.events 
--- @field on_trigger_fired_artillery defines.events 
--- @field on_train_changed_state defines.events 
--- @field on_player_created defines.events 
--- @field on_resource_depleted defines.events 
--- @field on_player_driving_changed_state defines.events 
--- @field on_force_created defines.events 
--- @field on_forces_merging defines.events 
--- @field on_player_cursor_stack_changed defines.events 
--- @field on_pre_entity_settings_pasted defines.events 
--- @field on_entity_settings_pasted defines.events 
--- @field on_player_main_inventory_changed defines.events 
--- @field on_player_armor_inventory_changed defines.events 
--- @field on_player_ammo_inventory_changed defines.events 
--- @field on_player_gun_inventory_changed defines.events 
--- @field on_player_placed_equipment defines.events 
--- @field on_player_removed_equipment defines.events 
--- @field on_pre_player_died defines.events 
--- @field on_player_died defines.events 
--- @field on_player_respawned defines.events 
--- @field on_player_joined_game defines.events 
--- @field on_player_left_game defines.events 
--- @field on_player_built_tile defines.events 
--- @field on_player_mined_tile defines.events 
--- @field on_robot_built_tile defines.events 
--- @field on_robot_mined_tile defines.events 
--- @field on_player_selected_area defines.events 
--- @field on_player_alt_selected_area defines.events 
--- @field on_player_changed_surface defines.events 
--- @field on_selected_entity_changed defines.events 
--- @field on_market_item_purchased defines.events 
--- @field on_player_dropped_item defines.events 
--- @field on_biter_base_built defines.events 
--- @field on_player_changed_force defines.events 
--- @field on_entity_renamed defines.events 
--- @field on_gui_selection_state_changed defines.events 
--- @field on_runtime_mod_setting_changed defines.events 
--- @field on_difficulty_settings_changed defines.events 
--- @field on_surface_created defines.events 
--- @field on_surface_deleted defines.events 
--- @field on_pre_surface_deleted defines.events 
--- @field on_player_mined_entity defines.events 
--- @field on_robot_mined_entity defines.events 
--- @field on_train_created defines.events 
--- @field on_gui_elem_changed defines.events 
--- @field on_player_setup_blueprint defines.events 
--- @field on_player_deconstructed_area defines.events 
--- @field on_player_configured_blueprint defines.events 
--- @field on_console_chat defines.events 
--- @field on_console_command defines.events 
--- @field on_player_removed defines.events 
--- @field on_pre_player_removed defines.events 
--- @field on_player_used_capsule defines.events 
--- @field script_raised_built defines.events 
--- @field script_raised_destroy defines.events 
--- @field script_raised_revive defines.events 
--- @field script_raised_teleported defines.events 
--- @field script_raised_set_tiles defines.events 
--- @field on_player_promoted defines.events 
--- @field on_player_demoted defines.events 
--- @field on_combat_robot_expired defines.events 
--- @field on_worker_robot_expired defines.events 
--- @field on_player_changed_position defines.events 
--- @field on_mod_item_opened defines.events 
--- @field on_gui_opened defines.events 
--- @field on_gui_closed defines.events 
--- @field on_gui_value_changed defines.events 
--- @field on_player_muted defines.events 
--- @field on_player_unmuted defines.events 
--- @field on_player_cheat_mode_enabled defines.events 
--- @field on_player_cheat_mode_disabled defines.events 
--- @field on_character_corpse_expired defines.events 
--- @field on_pre_ghost_deconstructed defines.events 
--- @field on_pre_ghost_upgraded defines.events 
--- @field on_player_pipette defines.events 
--- @field on_player_display_resolution_changed defines.events 
--- @field on_player_display_scale_changed defines.events 
--- @field on_pre_player_crafted_item defines.events 
--- @field on_player_cancelled_crafting defines.events 
--- @field on_chunk_charted defines.events 
--- @field on_technology_effects_reset defines.events 
--- @field on_force_reset defines.events 
--- @field on_land_mine_armed defines.events 
--- @field on_forces_merged defines.events 
--- @field on_player_trash_inventory_changed defines.events 
--- @field on_pre_player_left_game defines.events 
--- @field on_pre_surface_cleared defines.events 
--- @field on_surface_cleared defines.events 
--- @field on_chunk_deleted defines.events 
--- @field on_pre_chunk_deleted defines.events 
--- @field on_train_schedule_changed defines.events 
--- @field on_player_banned defines.events 
--- @field on_player_kicked defines.events 
--- @field on_player_unbanned defines.events 
--- @field on_rocket_launch_ordered defines.events 
--- @field on_script_path_request_finished defines.events 
--- @field on_ai_command_completed defines.events 
--- @field on_marked_for_upgrade defines.events 
--- @field on_cancelled_upgrade defines.events 
--- @field on_player_toggled_map_editor defines.events 
--- @field on_entity_cloned defines.events 
--- @field on_area_cloned defines.events 
--- @field on_brush_cloned defines.events 
--- @field on_game_created_from_scenario defines.events 
--- @field on_surface_imported defines.events 
--- @field on_surface_renamed defines.events 
--- @field on_player_toggled_alt_mode defines.events 
--- @field on_player_repaired_entity defines.events 
--- @field on_player_fast_transferred defines.events 
--- @field on_pre_robot_exploded_cliff defines.events 
--- @field on_robot_exploded_cliff defines.events 
--- @field on_entity_spawned defines.events 
--- @field on_cutscene_waypoint_reached defines.events 
--- @field on_unit_group_created defines.events 
--- @field on_unit_added_to_group defines.events 
--- @field on_unit_removed_from_group defines.events 
--- @field on_unit_group_finished_gathering defines.events 
--- @field on_build_base_arrived defines.events 
--- @field on_chart_tag_added defines.events 
--- @field on_chart_tag_modified defines.events 
--- @field on_chart_tag_removed defines.events 
--- @field on_lua_shortcut defines.events 
--- @field on_gui_location_changed defines.events 
--- @field on_gui_selected_tab_changed defines.events 
--- @field on_gui_switch_state_changed defines.events 
--- @field on_force_cease_fire_changed defines.events 
--- @field on_force_friends_changed defines.events 
--- @field on_string_translated defines.events 
--- @field on_script_trigger_effect defines.events 
--- @field on_player_set_quick_bar_slot defines.events 
--- @field on_pre_player_toggled_map_editor defines.events 
--- @field on_pre_script_inventory_resized defines.events 
--- @field on_script_inventory_resized defines.events 
--- @field on_entity_destroyed defines.events 
--- @field on_player_clicked_gps_tag defines.events 
--- @field on_player_flushed_fluid defines.events 
--- @field on_permission_group_edited defines.events 
--- @field on_pre_permission_string_imported defines.events 
--- @field on_permission_string_imported defines.events 
--- @field on_pre_permission_group_deleted defines.events 
--- @field on_permission_group_deleted defines.events 
--- @field on_permission_group_added defines.events 
--- @field on_cutscene_cancelled defines.events 
--- @field on_player_configured_spider_remote defines.events 
--- @field on_player_used_spider_remote defines.events 
--- @field on_spider_command_completed defines.events 
--- @field on_entity_logistic_slot_changed defines.events 
--- @field on_equipment_inserted defines.events 
--- @field on_equipment_removed defines.events 
--- @field on_player_reverse_selected_area defines.events 
--- @field on_player_alt_reverse_selected_area defines.events 
--- @field on_gui_hover defines.events 
--- @field on_gui_leave defines.events 
--- @field on_cutscene_started defines.events 
--- @field on_cutscene_finished defines.events 
----
defines.events = { }

